#ifndef UBERSDR_H_
#define UBERSDR_H_

#ifdef __cplusplus
extern "C" {
#endif

int uber_init(const char *vsname, const char *psname);
void uber_destroy(void);

void uber_clear(void);

void uber_enable_light(int idx);
void uber_disable_light(int idx);

void uber_enable_texmap(void);
void uber_disable_texmap(void);

void uber_enable_cubemap(void);
void uber_disable_cubemap(void);

void uber_enable_sphmap(void);
void uber_disable_sphmap(void);

void uber_enable_shadows(void);
void uber_disable_shadows(void);

unsigned int uber_vertex_shader(void);
unsigned int uber_pixel_shader(void);
unsigned int uber_program(void);

#ifdef __cplusplus
}
#endif

#endif	/* UBERSDR_H_ */
